/*
 * \brief  Azure SDK IoT * client base class
 * \author Timo Nicolai
 * \date   2023-03-05
 */

/*
 * Copyright (C) 2023 gapfruit AG
 */

#pragma once

/* local includes */
#include <azure_iot_client/azure/check.h>

namespace Azure {
	template<typename CLIENT> class IoT_client;
}


template<typename CLIENT>
class Azure::IoT_client
{
	protected:

		CLIENT _client { };

		template<typename T, typename FUNC, typename ...ARGS>
		T _get(char const *what, FUNC &&fn, ARGS &&...args) const
		{
			char buf[T::size()];

			check(fn(&_client,
			         static_cast<ARGS &&>(args)...,
			         buf,
			         sizeof(buf),
			         nullptr),
			      what);

			return T { buf };
		}
};
